/*******************************************************************************
 *  Copyright 2017-2018 Centre for Development of Advanced Computing(C-DAC), Pune
 *  
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *  
 *   http://www.apache.org/licenses/LICENSE-2.0
 *  
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *******************************************************************************/
package cdac.medinfo.sdk.dcm30_04.services.hangingprotocol.testcases.scu;

import java.io.IOException;

import cdac.medinfo.sdk.dcm30_04.baselibs.DataSet;
import cdac.medinfo.sdk.dcm30_04.baselibs.ImplicitDE;
import cdac.medinfo.sdk.dcm30_04.commoninterface.IDataElement;
import cdac.medinfo.sdk.dcm30_04.commoninterface.IDataSet;
import cdac.medinfo.sdk.dcm30_04.commoninterface.IDictionaryReader;
import cdac.medinfo.sdk.dcm30_04.enums.EnumLoggingLevel;
import cdac.medinfo.sdk.dcm30_04.enums.EnumPDUType;
import cdac.medinfo.sdk.dcm30_04.enums.EnumSOPClassUIDs;
import cdac.medinfo.sdk.dcm30_04.services.association.AAbort;
import cdac.medinfo.sdk.dcm30_04.services.association.AReleaseRQorRP;
import cdac.medinfo.sdk.dcm30_04.services.association.AssociateRQ;
import cdac.medinfo.sdk.dcm30_04.services.association.DefaultAssociation;
import cdac.medinfo.sdk.dcm30_04.services.association.RQPresContext;
import cdac.medinfo.sdk.dcm30_04.services.cget.commons.CGetRQ;
import cdac.medinfo.sdk.dcm30_04.services.cget.commons.CGetRSP;
import cdac.medinfo.sdk.dcm30_04.services.cget.scu.CGetSCU;
import cdac.medinfo.sdk.dcm30_04.services.dimsecommons.DicomMessage;
import cdac.medinfo.sdk.dcm30_04.services.scu.commons.SCUSession;
import cdac.medinfo.sdk.dcm30_04.utils.DicomConfig;
import cdac.medinfo.sdk.dcm30_04.utils.DicomConstants;
import cdac.medinfo.sdk.dcm30_04.utils.ISingleCollection;
import cdac.medinfo.sdk.dcm30_04.utils.SingleCollection;


/**
 * This class is implemented to test the hanging protocol SCU using CGetSCU class of SDK for DICOM.
 * In order to run the following class , please refer to this link($Link) to create the environment.
 * To implement an SCU of a particular we need to do the following things:
 * Create the SCUSession object which maintains the current session of the SCU. Its "start" method accepts
 * the SCP's IP Address and Port and tries to establish a connection with the SCP. Some ways to 
 * create an Association Request: 
 * 1)Use Default Association class to Load the association for requested service. User can load the association 
 * by specifying the Service Type in loadAssociation method of Default association. For e.g. here EnumServiceType.CFind
 * should be specified to load Association for C-get services. The association request for C-Get
 * is made according to  jars in the class path.
 * 2) Manually create object of AssociationRQ class and set all presentation contexts collection on it. 
 * More details provided in the API DOCS of AssociationRQ class.
 * After successful association is established the SCUSession stores the status of the Association with it.  
 * Create CGet object to send the C-Get Request to the respective SCP. Currently the "sendMessage" method 
 * of the hanging protocol SCU would wait after sending the C-Get-RQ until a suitable DIMSE response is received. 
 * When CGet request is send to the server with key attribute to be searched in the data set
 * then for the matches find (for key attribute at SCP side) it sends the Pending response which contains 
 * matched data set. Then success response is sent by SCP.
 * This operation is part of Synchronous mode request handling.  
 * Once the DIMSE response is received by the hanging protocol SCU it stores it into its collection
 * which then can be retrieved.
 * After this, create a A-Release-RQ in order to request for association release and send it using the
 * SCUSession object. This again is a blocking call and the SCUSession waits until a A-Release-RP is received.
 * At the end of an operation calling "close" on SCUSession would disconnect the connection made with the 
 * SCP and release all the acquired resources.
 * Instead of closing the session after a C-Get operation is complete,we can create another association
 * and send more requests. 
 * Also it is possible to create multiple C-Get-RQs and send them one by one on the same Association.
 */
public class HangingProtocolCGet_SCU 
{

	public static void main(String[] args) throws IOException
	{
		DicomConfig objDicomConfig = DicomConfig.createInstance();

		//enable logging,specify the path of the directory where log files are created.
		//User can specify any directory in place of 'c:\DCM_Logs'.
		//If no directory is defined by user to create logs then it is created in User Temp DIR.
		objDicomConfig.enableLogging(EnumLoggingLevel.INFO, "C:/DCM_Logs");
		

		/*
		 * creates object of CGet_SCU and Start C-Get SCU.
		 */
		HangingProtocolCGet_SCU objTestCGetSCU = new HangingProtocolCGet_SCU();
		objTestCGetSCU.start();
	}
	
	/**
	 * Starts CGet SCU.
	 */
	public void start()
	{
		//SCU Session.
		SCUSession objSession = null;

		try
		{
			//Create SCUSession object
			objSession = new SCUSession();
			
			/*
			 * Setting time out as 5000 milli second. It will wait 5000 milli seconds for read and write operation.
			 * If in the time specified (5000 ms) read or write operation is not performed then 
			 * session is time out.
			 */ 
			//objSession.setTimeOut(5000);

			/*
			 * Initializes the service types and populates the default association
			 */
			
			//RQ Present Context for Hanging Protocol
			RQPresContext objRQPresContextHangingProtocol = new RQPresContext();
			objRQPresContextHangingProtocol.setAbstractSyntaxName(EnumSOPClassUIDs.HANGINGPROTOCOLIOD.getValue());
			objRQPresContextHangingProtocol.addTransferSyntax(DicomConstants.TS_DEFAULT_IMPLICIT_VR_LITTLE_ENDIAN);

			RQPresContext objRQPresContextHangingProtocolCGet = new RQPresContext();
			objRQPresContextHangingProtocolCGet.setAbstractSyntaxName(EnumSOPClassUIDs.HANGINGPROTOCOL_INFORMATION_QUERY_GET.getValue());
			objRQPresContextHangingProtocolCGet.addTransferSyntax(DicomConstants.TS_DEFAULT_IMPLICIT_VR_LITTLE_ENDIAN);

			
			ISingleCollection<RQPresContext> objPressConColl = new SingleCollection<RQPresContext>();
			objPressConColl.add(objRQPresContextHangingProtocol);
			objPressConColl.add(objRQPresContextHangingProtocolCGet);

			DefaultAssociation objDefaultAssociation = new DefaultAssociation("SDK");
			objDefaultAssociation.loadAssociation(objPressConColl);

			//Create Association RQ
			AssociateRQ objAssociateRQ = objDefaultAssociation.getAssociationRQ("SDK");

			//Start SCU Session by providing the IP address and Port of SCP.
			objSession.start("localhost", 9000);

			//Create CGet SCU object using the current SCU Session.
			CGetSCU objCGetSCU = new CGetSCU(objSession);

			//The destination path where the retrieved dataset should be stored.
			objCGetSCU.setDestinationPath("C:/Storage/getImage");

			//Send the Association Request
			if(objSession.sendAssociationMessage(objAssociateRQ))
			{
				System.out.println("Assocaition is established");
				/*
				 * Creating DataSet for C-Get Request.
				 */
				IDataSet objIDataSet = new DataSet();
				IDictionaryReader objIDictionaryReader = objIDataSet.getDictionaryReader();
				
				objIDataSet.addDataElement(getDataElement(0x0000,0x0002, null, objIDictionaryReader));
				objIDataSet.addDataElement(getDataElement(0x0000,0x0120, null, objIDictionaryReader));
				objIDataSet.addDataElement(getDataElement(0x0000,0x0800, null, objIDictionaryReader));
				objIDataSet.addDataElement(getDataElement(0x0008,0x0016, "1.2.840.10008.5.1.4.38.1", objIDictionaryReader));
				objIDataSet.addDataElement(getDataElement(0x0008,0x0018, "1.2.840.10008.5.1.4.1.1.4", objIDictionaryReader));
				objIDataSet.addDataElement(getDataElement(0x0008,0x0060, "MR", objIDictionaryReader));
				objIDataSet.addDataElement(getDataElement(0x0072,0x0102,null, objIDictionaryReader));
				objIDataSet.addDataElement(getDataElement(0x0072,0x0104,null, objIDictionaryReader));
				
				//Create Default CGetRQ by giving the DataSet. This method uses
				// default values for the attributes in the request. These attributes can be
				//modified once the request object is created, before sending.
				CGetRQ objCGetRQ = CGetRQ.getDefaultRQ("1.2.840.10008.5.1.4.38.4", objIDataSet);

				//Send the C-Get-RQ and wait for a C-Get-RSP.
				//This method exits once the response is received. This response is 
				//added in the response collection maintained by the CGetSCU which
				//can be retrieved. This method return true if request is successfully sent 
				//to the SCP and false if the message cannot be sent to the SCP( for e.g. if 
				//the association status is false or if SOP class UID is not agreed in agreed association.
				if(objCGetSCU.sendMessage(objCGetRQ))
				{
					System.out.println("CGet operation performed");
					ISingleCollection<DicomMessage> objSingleCollection = objCGetSCU.getDIMSEResponse();
					System.out.println("Size of Response collection :: " + objSingleCollection.size());
					/*
					 * This will get the pending response from the Dicom Message and displays it.
					 */
					for(DicomMessage objDicomMessage : objSingleCollection)
					{
						CGetRSP objCGetRSP = new CGetRSP(objDicomMessage);
						System.out.println("Response Status  :" + Integer.toHexString(objCGetRSP.getStatus()));
					}
				}
				else
					System.out.println("CGet operation Failed");


				//Create A-Release-RQ to release the association
				AReleaseRQorRP objAReleaseRQorRP = new AReleaseRQorRP(EnumPDUType.RELEASE_RQ);

				//Send the A-Release-RQ
				if(objSession.sendAssociationMessage(objAReleaseRQorRP))
				{
					System.out.println("Release Response received");

					//When successful A-Release-RP is received, close the Session.
					//Please note that instead of closing the session we can create 
					//another association and send more requests. Also it is possible
					//to create multiple C-Get-RQs and send them one by one.
					objSession.close();
				}

				//In case an ABORT is received from SCP during the C-Get operation
				if(objSession.getDIMSEAssociation() instanceof AAbort)
				{
					System.out.println("Abort arrives. Closing session.");
					objSession.close();
				}
			}
			else
			{
				System.out.println("Association cannot be established");
				objSession.close();
			}
		}
		catch(Exception e)
		{
			e.printStackTrace();
			objSession.close();
		}
	}
	/**
	 * Get the data element belonging to the information provided
	 */
	private IDataElement getDataElement(int GroupNo,int ElementNo,Object objVal,IDictionaryReader objDictionaryReader)
	{
		IDataElement objIDataElement = new ImplicitDE(GroupNo, ElementNo,objVal,objDictionaryReader);
		return objIDataElement;
	}
}
